#!/bin/bash

ROOT_DIR=/var/www/html/nextcloud
DATA_DIR=/home/www-data/var/www/html/nextcloud

# RAZ
if [ "$1" == "RAZ" ];then
    . /var/www/nextcloud/fonctions.sh
    EchoRouge =========================================
    EchoRouge RAZ 
    EchoRouge =========================================
    
    echo "    >> Suppression des anciennes sources"
    rm -rf /var/www/html/nextcloud
    rm -rf /home/www-data/var/www/html/nextcloud
    
    echo "    >> Suppression de la BDD"
    mysql_pwd.py 123456 root >/dev/null
    echo "DROP DATABASE nextcloud;" | mysql -uroot -p123456 -hlocalhost

    echo "    >> Templeting"
    service creoled restart
    for f in /usr/share/eole/creole/distrib/nextcloud*;  do FILENAME=`basename ${f%%}`; echo ${FILENAME}; CreoleCat -dt ${FILENAME} > /dev/null 2>&1; done;
    
    echo "    >> eoleDB"
    /usr/share/eole/posttemplate/01-eoledb >/dev/null
    mysql_pwd.py 123456 root >/dev/null
    rm -rf nextcloud.db
    cp /usr/share/envole/eoledb/nextcloud /var/www/nextcloud/nextcloud.db
 
    echo ""
    EchoRouge =========================================
    EchoRouge INSTALATION 
    EchoRouge =========================================
fi

# Suppression des anciennes sources
rm -rf /var/www/nextcloud/nextcloud-12.0.3
rm -rf /var/www/nextcloud/nextcloud-13.0.6
rm -rf /var/www/nextcloud/nextcloud-14.0.3

# Installation de la version 19.0.1
if [ ! -f /var/www/html/nextcloud/version.php ];then
    echo "    >> Installation de la version 19.0.1"

    # Création du répertoire ${DATA_DIR}
    if [ ! -d ${DATA_DIR} ];then
        mkdir -p /home/www-data/var/www/html
        /bin/cp -R /var/www/nextcloud/patch/envoledata ${DATA_DIR}
        /bin/chown -R www-data:www-data ${DATA_DIR}      
    fi

    # Include des login de connexion bdd
    . /var/www/nextcloud/nextcloud.db

    # Sauvegarder le fichier de config normalement appliqué après installation de 19.0.1
    rm -rf /var/www/nextcloud/config.php
    cp /var/www/html/nextcloud/config/config.php /var/www/nextcloud/

    # Suppression du ficher de la version car propre a un upgrade
    rm -rf /var/www/nextcloud/nextcloud-19.0.1/config/config.php
    rm -rf /var/www/html/nextcloud
    
    # Appliquer les sources de la 19.0.1
    cp -rf /var/www/nextcloud/nextcloud-19.0.1 ${ROOT_DIR}

    # Placer les permissions
    /bin/chown -R www-data:www-data ${ROOT_DIR}
    /bin/chmod g+w ${ROOT_DIR}/config -R
    /bin/chmod u+x ${ROOT_DIR}/occ
    /bin/chmod g+w ${ROOT_DIR}/apps -R
    /bin/chown -R www-data:www-data ${DATA_DIR}      

    # Lancer l'installation
    sudo -u www-data php ${ROOT_DIR}/occ  maintenance:install --database-host "${dbhostNEXTCLOUD}" --database "mysql" --database-name "nextcloud"  --database-user "nextcloud" --database-pass "${dbpassNEXTCLOUD}" --admin-user "admin" --admin-pass "password" --data-dir "${DATA_DIR}"

    # Replacer la config normal
    mv -f /var/www/nextcloud/config.php /var/www/html/nextcloud/config/config.php
    
    # Placer les permissions
    /bin/chown -R www-data:www-data ${ROOT_DIR}
    /bin/chmod g+w ${ROOT_DIR}/config -R
    /bin/chmod u+x ${ROOT_DIR}/occ
    /bin/chmod g+w ${ROOT_DIR}/apps -R
    /bin/chown -R www-data:www-data ${DATA_DIR}      

    sudo -u www-data ${ROOT_DIR}/occ files:scan --all -q
    sudo -u www-data ${ROOT_DIR}/occ maintenance:repair -q  
    echo "    >> Fin installation"
fi

# Installation de la version 15.0.14
if [ -f /var/www/html/nextcloud/version.php ];then
    owncloudversion=`grep "OC_VersionString" "/var/www/html/nextcloud/version.php" | awk -F "'" '{print $2}'`
    if [ "$owncloudversion" == "14.0.3" ];then
        echo "    >> Installation de la version 15.0.14"
        rm -rf /var/www/html/nextcloud
        cp -rf /var/www/nextcloud/nextcloud-15.0.14 ${ROOT_DIR}

        /bin/chown -R www-data:www-data ${ROOT_DIR}
        /bin/chmod g+w ${ROOT_DIR}/config -R
        /bin/chmod u+x ${ROOT_DIR}/occ
        /bin/chmod g+w ${ROOT_DIR}/apps -R
        /bin/chown -R www-data:www-data ${DATA_DIR}      

        sudo -u www-data php ${ROOT_DIR}/occ app:disable user_cas -q
        sudo -u www-data /var/www/html/nextcloud/occ upgrade
    fi
fi

# Installation de la version 16.0.9
if [ -f /var/www/html/nextcloud/version.php ];then
    owncloudversion=`grep "OC_VersionString" "/var/www/html/nextcloud/version.php" | awk -F "'" '{print $2}'`
    if [ "$owncloudversion" == "15.0.14" ];then
        echo "    >> Installation de la version 16.0.9"
        rm -rf /var/www/html/nextcloud
        cp -rf /var/www/nextcloud/nextcloud-16.0.9 ${ROOT_DIR}

        /bin/chown -R www-data:www-data ${ROOT_DIR}
        /bin/chmod g+w ${ROOT_DIR}/config -R
        /bin/chmod u+x ${ROOT_DIR}/occ
        /bin/chmod g+w ${ROOT_DIR}/apps -R
        /bin/chown -R www-data:www-data ${DATA_DIR}      

        sudo -u www-data php ${ROOT_DIR}/occ app:disable user_cas -q
        sudo -u www-data /var/www/html/nextcloud/occ upgrade
    fi
fi

# Installation de la version 17.0.5
if [ -f /var/www/html/nextcloud/version.php ];then
    owncloudversion=`grep "OC_VersionString" "/var/www/html/nextcloud/version.php" | awk -F "'" '{print $2}'`
    if [ "$owncloudversion" == "16.0.9" ];then
        echo "    >> Installation de la version 17.0.5"
        rm -rf /var/www/html/nextcloud
        cp -rf /var/www/nextcloud/nextcloud-17.0.5 ${ROOT_DIR}

        /bin/chown -R www-data:www-data ${ROOT_DIR}
        /bin/chmod g+w ${ROOT_DIR}/config -R
        /bin/chmod u+x ${ROOT_DIR}/occ
        /bin/chmod g+w ${ROOT_DIR}/apps -R
        /bin/chown -R www-data:www-data ${DATA_DIR}      

        sudo -u www-data php ${ROOT_DIR}/occ app:disable user_cas -q
        sudo -u www-data /var/www/html/nextcloud/occ upgrade
    fi
fi

# Installation de la version 18.0.4
if [ -f /var/www/html/nextcloud/version.php ];then
    owncloudversion=`grep "OC_VersionString" "/var/www/html/nextcloud/version.php" | awk -F "'" '{print $2}'`
    if [ "$owncloudversion" == "17.0.5" ];then
        echo "    >> Installation de la version 18.0.4"
        rm -rf /var/www/html/nextcloud
        cp -rf /var/www/nextcloud/nextcloud-18.0.4 ${ROOT_DIR}

        /bin/chown -R www-data:www-data ${ROOT_DIR}
        /bin/chmod g+w ${ROOT_DIR}/config -R
        /bin/chmod u+x ${ROOT_DIR}/occ
        /bin/chmod g+w ${ROOT_DIR}/apps -R
        /bin/chown -R www-data:www-data ${DATA_DIR}      

        sudo -u www-data php ${ROOT_DIR}/occ app:disable user_cas -q
        sudo -u www-data /var/www/html/nextcloud/occ upgrade
    fi
fi

# Installation de la version 19.0.1
if [ -f /var/www/html/nextcloud/version.php ];then
    owncloudversion=`grep "OC_VersionString" "/var/www/html/nextcloud/version.php" | awk -F "'" '{print $2}'`
    if [ "$owncloudversion" == "18.0.4" ];then
        echo "    >> Installation de la version 19.0.1"
        rm -rf /var/www/html/nextcloud
        cp -rf /var/www/nextcloud/nextcloud-19.0.1 ${ROOT_DIR}

        /bin/chown -R www-data:www-data ${ROOT_DIR}
        /bin/chmod g+w ${ROOT_DIR}/config -R
        /bin/chmod u+x ${ROOT_DIR}/occ
        /bin/chmod g+w ${ROOT_DIR}/apps -R
        /bin/chown -R www-data:www-data ${DATA_DIR}      

        sudo -u www-data php ${ROOT_DIR}/occ app:disable user_cas -q
        sudo -u www-data /var/www/html/nextcloud/occ upgrade
    fi
fi

echo "    >> Appliquer Patch Envole"
# Supprimer totalement les apps purement Envole pour les regenerer proprement en cas de relicat de codes
/bin/rm -rf ${ROOT_DIR}/apps/user_cas
/bin/rm -rf ${ROOT_DIR}/apps/occtools
# Appliquer les patchs
/bin/cp -rf /var/www/nextcloud/patch/user_cas           ${ROOT_DIR}/apps/
/bin/cp -rf /var/www/nextcloud/patch/user_ldap          ${ROOT_DIR}/apps/
/bin/cp -rf /var/www/nextcloud/patch/occtools           ${ROOT_DIR}/apps/
/bin/cp -rf /var/www/nextcloud/patch/ftpcas             ${ROOT_DIR}/apps/
/bin/cp -rf /var/www/nextcloud/patch/lib                ${ROOT_DIR}/
/bin/cp -rf /var/www/nextcloud/patch/htaccess/.htaccess ${ROOT_DIR}/

# Attribution des droits minimaux
echo "    >> Permissions"
/bin/chown -R www-data:www-data ${ROOT_DIR}
/bin/chmod g+w ${ROOT_DIR}/config -R
/bin/chmod u+x ${ROOT_DIR}/occ
/bin/chmod g+w ${ROOT_DIR}/apps -R

echo "    >> Activation app LDAP"
sudo -u www-data php ${ROOT_DIR}/occ app:enable user_ldap -q
sudo -u www-data php /var/www/html/nextcloud/occ ldap:show-config s01 > /tmp/nextcloud-ldap.txt
if grep -q "Invalid configID" /tmp/nextcloud-ldap.txt;then
	sudo -u www-data php /var/www/html/nextcloud/occ ldap:create-empty-config -q
fi

sudo -u www-data php /var/www/html/nextcloud/occ config:app:set user_ldap bgjRefreshInterval --value=300 -q
sudo -u www-data php /var/www/html/nextcloud/occ ldap:set-config s01 ldapAgentName "%%ldap_reader"
sudo -u www-data php /var/www/html/nextcloud/occ ldap:set-config s01 ldapAgentPassword %%pwdreader("",%%ldap_reader_passfile)
sudo -u www-data php /var/www/html/nextcloud/occ ldap:set-config s01 ldapBase "%%ldap_base_dn"
sudo -u www-data php /var/www/html/nextcloud/occ ldap:set-config s01 ldapBaseGroups "%%ldap_base_dn"
sudo -u www-data php /var/www/html/nextcloud/occ ldap:set-config s01 ldapBaseUsers "%%ldap_base_dn"
sudo -u www-data php /var/www/html/nextcloud/occ ldap:set-config s01 ldapConfigurationActive "1"
sudo -u www-data php /var/www/html/nextcloud/occ ldap:set-config s01 ldapExperiencedAdmin "0"
sudo -u www-data php /var/www/html/nextcloud/occ ldap:set-config s01 ldapExpertUUIDUserAttr "%%ldap_match_attribute"
sudo -u www-data php /var/www/html/nextcloud/occ ldap:set-config s01 ldapGroupFilter "(&(|(%%ldap_filter_group)))"
sudo -u www-data php /var/www/html/nextcloud/occ ldap:set-config s01 ldapGroupFilterObjectclass "%%getVar('ldap_filter_group_class', 'posixGroup')"
sudo -u www-data php /var/www/html/nextcloud/occ ldap:set-config s01 ldapGroupMemberAssocAttr "%%getVar('ldap_member_group_attribute', 'memberUid')"
sudo -u www-data php /var/www/html/nextcloud/occ ldap:set-config s01 ldapHost "%%adresse_ip_ldap"
sudo -u www-data php /var/www/html/nextcloud/occ ldap:set-config s01 ldapLoginFilter "(&(|(%%ldap_filter_user))(%%ldap_match_attribute=%uid))"
sudo -u www-data php /var/www/html/nextcloud/occ ldap:set-config s01 ldapPort "%%ldap_port"
sudo -u www-data php /var/www/html/nextcloud/occ ldap:set-config s01 ldapUserFilter "(&(%%ldap_match_attribute=*)(%%ldap_filter_user)(!(description=Computer)))"
sudo -u www-data php /var/www/html/nextcloud/occ ldap:set-config s01 ldapUserFilterObjectclass "%%getVar('ldap_filter_user_class', 'inetOrgPerson')"
sudo -u www-data php /var/www/html/nextcloud/occ ldap:set-config s01 ldapEmailAttribute "%%ldap_fill_mail"
sudo -u www-data php /var/www/html/nextcloud/occ ldap:set-config s01 ldapCacheTTL "300"
sudo -u www-data php /var/www/html/nextcloud/occ ldap:set-config s01 ldapPagingSize "0"
%if %%getVar('ldap_tls', 'non') == 'oui'
sudo -u www-data php /var/www/html/nextcloud/occ ldap:set-config s01 ldapTLS "1"
%end if


echo "    >> Activation app USER CAS"
sudo -u www-data php ${ROOT_DIR}/occ app:enable user_cas -q
sudo -u www-data php /var/www/html/nextcloud/occ config:app:set user_cas cas_access_allow_groups --value= -q
sudo -u www-data php /var/www/html/nextcloud/occ config:app:set user_cas cas_access_group_quotas --value= -q
sudo -u www-data php /var/www/html/nextcloud/occ config:app:set user_cas cas_autocreate --value=1 -q
sudo -u www-data php /var/www/html/nextcloud/occ config:app:set user_cas cas_cert_path --value= -q
sudo -u www-data php /var/www/html/nextcloud/occ config:app:set user_cas cas_debug_file --value= -q
sudo -u www-data php /var/www/html/nextcloud/occ config:app:set user_cas cas_default_group --value= -q
sudo -u www-data php /var/www/html/nextcloud/occ config:app:set user_cas cas_disable_logout --value=0 -q
sudo -u www-data php /var/www/html/nextcloud/occ config:app:set user_cas cas_displayName_mapping --value= -q
sudo -u www-data php /var/www/html/nextcloud/occ config:app:set user_cas cas_ecas_accepted_strengths --value= -q
sudo -u www-data php /var/www/html/nextcloud/occ config:app:set user_cas cas_ecas_assurance_level --value= -q
sudo -u www-data php /var/www/html/nextcloud/occ config:app:set user_cas cas_ecas_attributeparserenabled --value=0 -q
sudo -u www-data php /var/www/html/nextcloud/occ config:app:set user_cas cas_ecas_request_full_userdetails --value=0 -q
sudo -u www-data php /var/www/html/nextcloud/occ config:app:set user_cas cas_ecas_retrieve_groups --value= -q
sudo -u www-data php /var/www/html/nextcloud/occ config:app:set user_cas cas_email_mapping --value=email -q
sudo -u www-data php /var/www/html/nextcloud/occ config:app:set user_cas cas_force_login --value=1 -q
sudo -u www-data php /var/www/html/nextcloud/occ config:app:set user_cas cas_force_login_exceptions --value= -q
sudo -u www-data php /var/www/html/nextcloud/occ config:app:set user_cas cas_group_mapping --value= -q
sudo -u www-data php /var/www/html/nextcloud/occ config:app:set user_cas cas_handlelogout_servers --value= -q
sudo -u www-data php /var/www/html/nextcloud/occ config:app:set user_cas cas_link_to_ldap_backend --value=1 -q
sudo -u www-data php /var/www/html/nextcloud/occ config:app:set user_cas cas_php_cas_path --value= -q
sudo -u www-data php /var/www/html/nextcloud/occ config:app:set user_cas cas_protected_groups --value= -q
sudo -u www-data php /var/www/html/nextcloud/occ config:app:set user_cas cas_server_hostname --value=%%eolesso_adresse -q
sudo -u www-data php /var/www/html/nextcloud/occ config:app:set user_cas cas_server_path --value=%%eolesso_cas_folder -q
sudo -u www-data php /var/www/html/nextcloud/occ config:app:set user_cas cas_server_port --value=%%eolesso_port -q
sudo -u www-data php /var/www/html/nextcloud/occ config:app:set user_cas cas_server_version --value=2.0 -q
sudo -u www-data php /var/www/html/nextcloud/occ config:app:set user_cas cas_service_url --value= -q
sudo -u www-data php /var/www/html/nextcloud/occ config:app:set user_cas cas_update_user_data --value=1 -q
sudo -u www-data php /var/www/html/nextcloud/occ config:app:set user_cas enabled --value=yes -q
sudo -u www-data php /var/www/html/nextcloud/occ config:app:set user_cas installed_version --value=1.5.6 -q
sudo -u www-data php /var/www/html/nextcloud/occ config:app:set user_cas types --value=prelogin,authentication -q
sudo -u www-data php /var/www/html/nextcloud/occ config:app:set user_cas cas_use_proxy --value=0 -q

echo "    >> Activation app CALENDAR"
sudo -u www-data php ${ROOT_DIR}/occ app:enable calendar -q

echo "    >> Activation app DECK"
sudo -u www-data php ${ROOT_DIR}/occ app:enable deck -q

echo "    >> Activation app DRAWIO"
sudo -u www-data php ${ROOT_DIR}/occ app:enable drawio -q

echo "    >> Activation app TASKS"
sudo -u www-data php ${ROOT_DIR}/occ app:enable tasks -q

echo "    >> Activation app FILES EXTERNAL"
sudo -u www-data php ${ROOT_DIR}/occ app:enable files_external -q

echo "    >> Activation app FILES MINDMAP"
sudo -u www-data php ${ROOT_DIR}/occ app:enable files_mindmap -q

echo "    >> Activation app OCCTOOLS"
sudo -u www-data php ${ROOT_DIR}/occ app:enable occtools -q

echo "    >> Activation app GROUPFOLDERS"
sudo -u www-data php ${ROOT_DIR}/occ app:enable groupfolders -q


%if %%getVar("activer_proftpd", 'non') == "oui" or %%getVar("nextcloud_activer_ftpdistant", 'non') == "oui"
echo "    >> Activation app FTPCAS"
sudo -u www-data php ${ROOT_DIR}/occ app:enable ftpcas -q
%else
sudo -u www-data php ${ROOT_DIR}/occ app:disable ftpcas -q
%end if

echo "    >> Activation Index"
sudo -u www-data php  ${ROOT_DIR}/occ db:add-missing-indices
yes | sudo -u www-data php  ${ROOT_DIR}/occ db:convert-filecache-bigint

echo "    >> Désactivé notification de mise à jour"
sudo -u www-data php  ${ROOT_DIR}/occ config:app:set updatenotification notify_groups --value="[]" -q

echo "    >> Execution tache CRON"
sudo -u www-data php -f /var/www/html/nextcloud/cron.php

%if %%getVar("activer_addadmin", 'non') == "oui"
echo "    >> Second admin"
sudo -u www-data php ${ROOT_DIR}/occ group:adduser admin %%uid_addadmin -q
%end if

systemctl restart nextcloud.service

echo ""




